package com.hokori.webwx.Api;

import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class PersonalAPI {
    @Value("${wx.host}")
    private String host;
    
    @Value("${wx.tokenid}")
    private String tokenid;
    
    private String getUrl() {
        return host;
    }

    public String getProfile(String appid) {
        log.info("获取个人信息");
        Unirest.setTimeouts(0, 0);
        try {
            HttpResponse<String> response = Unirest.post(getUrl() + "/personal/getProfile")
            .header("X-GEWE-TOKEN", tokenid)
            .header("Content-Type", "application/json")
            .body("{\n  \"appId\": \"" + appid + "\"\n}")
            .asString();
            log.info("获取成功");
           return response.getBody();
        } catch (Exception e) {
            log.error("设备列表请求失败", e);
            return "请求失败";
        }
    }
}
