package com.hokori.webwx.Api;

import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;
import org.json.JSONObject;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class ck {


    @Value("${wx.host}")
    private String host;
    
    @Value("${wx.tokenid}")
    private String tokenid;
    
    private String getUrl() {
        return host;
    }

    public String getLoginQrCode(String appid) {
        Unirest.setTimeouts(0, 0);
        try {
            HttpResponse<String> response = Unirest.post(getUrl() + "/login/getLoginQrCode")
            .header("X-GEWE-TOKEN", tokenid)
            .header("Content-Type", "application/json")
            .body("{\n  \"appId\": \"" + appid + "\"\n}")
            .asString();
           return response.getBody();
        } catch (Exception e) {
            log.error("设备列表请求失败", e);
            return "请求失败";
        }
    }

    public String checkLogin(String appid, String uuid, String captchCode) {
        Unirest.setTimeouts(0, 0);
        try {
            HttpResponse<String> response = Unirest.post(getUrl() + "/login/checkLogin")
            .header("X-GEWE-TOKEN", tokenid)
            .header("Content-Type", "application/json")
            .body("{\n  \"appId\": \"" + appid + "\",\n  \"uuid\": \"" + uuid + "\",\n  \"uuid\": \"" + captchCode + "\"\n}")
            .asString();
           return response.getBody();
        } catch (Exception e) {
            log.error("设备列表请求失败", e);
            return "请求失败";
        }
    }
    public String checkLogin(String appid, String uuid) {
        Unirest.setTimeouts(0, 0);
        try {
            HttpResponse<String> response = Unirest.post(getUrl() + "/login/checkLogin")
            .header("X-GEWE-TOKEN", tokenid)
            .header("Content-Type", "application/json")
            .body("{\n  \"appId\": \"" + appid + "\",\n  \"uuid\": \"" + uuid + "\"\n}")
            .asString();
           return response.getBody();
        } catch (Exception e) {
            log.error("设备列表请求失败", e);
            return "请求失败";
        }
    }


    public String deviceList() {
        Unirest.setTimeouts(0, 0);
        try {
            HttpResponse<String> response = Unirest.post(getUrl() + "/login/deviceList")
            .header("X-GEWE-TOKEN", tokenid)
            .header("Content-Type", "application/json")
            .asString();
           return response.getBody();
        } catch (Exception e) {
            log.error("设备列表请求失败", e);
            return "列表获取失败";
        }
    }

    public Boolean checkOnline(String appid) {
        Unirest.setTimeouts(0, 0);
        try {
            HttpResponse<String> response = Unirest.post(getUrl() + "/login/checkOnline")
            .header("X-GEWE-TOKEN", tokenid)
            .header("Content-Type", "application/json")
            .body("{\n  \"appId\": \"" + appid + "\"\n}")
            .asString();

           String body = response.getBody();
           
           // 解析JSON响应
           org.json.JSONObject jsonObject = new org.json.JSONObject(body);
           
           // 检查ret值是否为200
           if (jsonObject.getInt("ret") == 200) {
               // 提取并返回data字段的布尔值
               return jsonObject.getBoolean("data");
           } else {
               log.error("请求返回错误: " + jsonObject.getString("msg"));
               return false;
           }
        } catch (Exception e) {
            log.error("检查设备在线状态失败", e);
            return false;
        }
    }

}
